
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>EMULSION Manual &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="1. Information" href="pages/Information.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="emulsion-manual">
<h1>EMULSION Manual<a class="headerlink" href="#emulsion-manual" title="Permalink to this headline">¶</a></h1>
<p><img alt="badge-license" src="https://img.shields.io/badge/license-Apache--2.0-8cd0c3.svg" /> <img alt="badge-release" src="https://img.shields.io/badge/version-1.1.1-f16152.svg" /></p>
<p>Framework EMULSION is intended for modellers in epidemiology, to help
them design, simulate, and revise complex mechanistic stochastic
models, without having to write or rewrite huge amounts of code.</p>
<p>It comes with a <em>Domain-Specific Language</em> to represent all components
of epidemiological models (assumptions, model structure,
parameters…) in an explicit, intelligible and revisable way, and
thus facilitate interactions with other scientists (biologists,
veterinarians, economists…) throughout the modelling
process. EMULSION models are automatically processed by a modular
simulation engine, which, if needed, can also incorporate small code
add-ons for representing very specific features of a model
(<a class="reference internal" href="#emulsion-notool"><span class="std std-numref">Fig. 1</span></a>).</p>
<p>Models can use classical modelling paradigms (compartments,
individual-based models, metapopulations) and multiple scales (from
individuals to metapopulations), thanks to recent research in
Artificial Intelligence (see <a class="reference internal" href="pages/Information.html#information"><span class="std std-ref">Information</span></a>).</p>
<div class="figure align-center" id="id1">
<span id="emulsion-notool"></span><img alt="_images/emulsion-notool.jpg" src="_images/emulsion-notool.jpg" />
<p class="caption"><span class="caption-number">Fig. 1 </span><span class="caption-text">Principles of framework EMULSION</span></p>
</div>
<div class="section" id="table-of-contents">
<h2>Table of contents<a class="headerlink" href="#table-of-contents" title="Permalink to this headline">¶</a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="pages/Information.html">1. Information</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Information.html#contributors-and-contact">1.1. Contributors and contact</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Information.html#how-to-cite">1.2. How to cite</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Information.html#selected-publications">1.3. Selected publications</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Information.html#acknowledgements">1.4. Acknowledgements</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Install.html">2. Installation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#requirements">2.1. Requirements</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#install-with-pip-recommended">2.2. Install with <code class="docutils literal notranslate"><span class="pre">pip</span></code> (recommended)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Install.html#linux-and-macos">Linux and MacOS:</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Install.html#windows">Windows</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#install-third-party-software">2.3. Install third-party software</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Install.html#linux">Linux</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Install.html#macos">MacOS</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Install.html#id1">Windows</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#test-your-installation">2.4. Test your installation</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#alternative-1-install-with-git">2.5. Alternative 1: install with <code class="docutils literal notranslate"><span class="pre">git</span></code></a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Install.html#alternative-2-install-development-version">2.6. Alternative 2: install development version</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Getting_started.html">3. Getting started with EMULSION</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#running-emulsion">3.1. Running EMULSION</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#producing-model-diagrams">3.2. Producing model diagrams</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#viewing-parameters">3.3. Viewing parameters</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#changing-parameters">3.4. Changing parameters</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#changing-the-model">3.5. Changing the model</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Getting_started.html#going-further">3.6. Going further…</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_principles.html">4. Modelling principles</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_principles.html#individuals-populations-metapopulations">4.1. Individuals, populations, metapopulations</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_principles.html#from-flow-diagrams-to-state-machines">4.2. From flow diagrams to state machines</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_principles.html#flow-diagrams">Flow diagrams</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_principles.html#state-machines">State machines</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_language_basics.html">5. Modelling language (basics)</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_basics.html#yaml-syntax-in-a-nutshell">5.1. YAML Syntax in a nutshell</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_basics.html#model-structure">5.2. Model structure</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#model-name"><code class="docutils literal notranslate"><span class="pre">model_name</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#model-info"><code class="docutils literal notranslate"><span class="pre">model_info</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#time-info"><code class="docutils literal notranslate"><span class="pre">time_info</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#state-machines"><code class="docutils literal notranslate"><span class="pre">state_machines</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#levels"><code class="docutils literal notranslate"><span class="pre">levels</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#grouping"><code class="docutils literal notranslate"><span class="pre">grouping</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#processes"><code class="docutils literal notranslate"><span class="pre">processes</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#parameters"><code class="docutils literal notranslate"><span class="pre">parameters</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#prototypes"><code class="docutils literal notranslate"><span class="pre">prototypes</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#initial-conditions"><code class="docutils literal notranslate"><span class="pre">initial_conditions</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#outputs"><code class="docutils literal notranslate"><span class="pre">outputs</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#actions"><code class="docutils literal notranslate"><span class="pre">actions</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_basics.html#statevars"><code class="docutils literal notranslate"><span class="pre">statevars</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#compartments-ibm-or-hybrid-models">6.1. Compartments, IBM or hybrid models?</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#master-state-machines">6.2. Master state machines</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#set-states-attributes">Set states attributes</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#customize-transitions">Customize transitions</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#produce-new-individuals">Produce new individuals</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#state-machines-without-transitions">State machines without transitions</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#design-prototypes-for-typical-individuals-or-populations">6.3. Design prototypes for typical individuals or populations</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#define-prototypes">Define prototypes</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#default-prototypes">Default prototypes</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#data-based-prototype-collections">Data-based prototype collections</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Modelling_language_advanced.html#order-of-variables-assignment-in-prototypes">Order of variables assignment in prototypes</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#regulate-time">6.4. Regulate time</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#complexify-grouping">6.5. Complexify grouping</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#aggregate-variables">6.6. Aggregate variables</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#automatic-variables">6.7. Automatic variables</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#built-in-functions">6.8. Built-in functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#built-in-actions">6.9. Built-in actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#changing-scale-metapopulations">6.10. Changing scale: metapopulations</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Modelling_language_advanced.html#connecting-to-python-code-add-ons">6.11. Connecting to Python code add-ons</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Feature_examples.html">7. Feature examples</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model">7.1. SIR model</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#seirs-model">7.2. SEIRS model</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sirs-model-with-periodic-external-risk">7.3. SIRS model with periodic external risk</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#custom-state-durations">7.4. Custom state durations</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-basic-demography-births-deaths">7.5. SIR model with basic demography (births/deaths)</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-age-groups">7.6. SIR model with age groups</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-age-groups-and-random-initialization">7.7. SIR model with age groups and random initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-age-groups-and-data-based-prototypes">7.8. SIR model with age groups and data-based prototypes</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-cumulative-incidence">7.9. SIR model with cumulative incidence</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-individual-actions-and-variable-aggregation">7.10. SIR model with individual actions and variable aggregation</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-age-groups-and-explicit-age">7.11. SIR model with age groups and explicit age</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-explicit-gestation">7.12. SIR model with explicit gestation</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-structured-population">7.13. SIR model with structured population</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-metapopulation">7.14. SIR model with metapopulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="pages/Feature_examples.html#sir-model-with-metapopulation-and-data-driven-movements">7.15. SIR model with metapopulation and data-driven movements</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/Release_notes.html">8. Release notes</a><ul>
<li class="toctree-l2"><a class="reference internal" href="pages/Release_notes.html#notes-on-emulsion-1-1">8.1. Notes on EMULSION 1.1</a><ul>
<li class="toctree-l3"><a class="reference internal" href="pages/Release_notes.html#documentation">Documentation</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Release_notes.html#command-line">Command-line</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Release_notes.html#modelling-language">Modelling language</a></li>
<li class="toctree-l3"><a class="reference internal" href="pages/Release_notes.html#bugfixes">Bugfixes</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="pages/Release_notes.html#notes-on-emulsion-1-0">8.2. Notes on EMULSION 1.0</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="emulsion_for_modellers.html">10. High-level functions for model designers</a><ul>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#functions-available-for-models">10.1. Functions Available for Models</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#rates-probabilities">10.2. Rates / probabilities</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#computations">10.3. Computations</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#selecting-agents">10.4. Selecting agents</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#durations">10.5. Durations</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#agent-state-and-variable-changes">10.6. Agent State and Variable Changes</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion_for_modellers.html#introspection">10.7. Introspection</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="emulsion.html">11. emulsion package</a><ul>
<li class="toctree-l2"><a class="reference internal" href="emulsion.html#subpackages">11.1. Subpackages</a><ul>
<li class="toctree-l3"><a class="reference internal" href="emulsion.agent.html">emulsion.agent package</a></li>
<li class="toctree-l3"><a class="reference internal" href="emulsion.model.html">emulsion.model package</a></li>
<li class="toctree-l3"><a class="reference internal" href="emulsion.tools.html">emulsion.tools package</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="emulsion.html#submodules">11.2. Submodules</a></li>
<li class="toctree-l2"><a class="reference internal" href="emulsion.html#module-emulsion.init_emulsion">11.3. emulsion.init_emulsion module</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="indices-and-tables">
<h3>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></li>
<li><a class="reference internal" href="py-modindex.html"><span class="std std-ref">Module Index</span></a></li>
<li><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></li>
</ul>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="#">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="#">Documentation overview</a><ul>
      <li>Next: <a href="pages/Information.html" title="next chapter">1. Information</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
      |
      <a href="_sources/index.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>